org.apache.lucene.geo3d

## Class GeoDegeneratePoint

- java.lang.Object
- - org.apache.lucene.geo3d.Vector
  - - org.apache.lucene.geo3d.GeoPoint
    - - org.apache.lucene.geo3d.GeoDegeneratePoint

- All Implemented Interfaces:
    GeoArea, GeoBBox, GeoCircle, GeoDistance, GeoDistanceShape, GeoMembershipShape, GeoOutsideDistance, GeoShape, GeoSizeable, Membership

      public class GeoDegeneratePoint
      extends GeoPoint
      implements GeoBBox, GeoCircle

  This class represents a degenerate point bounding box. It is not a simple GeoPoint because we must have the latitude and longitude.
  NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected GeoPoint[]` | `edgePoints` Edge point is an area containing just this
    `protected PlanetModel` | `planetModel` Current planet model, since we don't extend BasePlanetObject

    - ### Fields inherited from class org.apache.lucene.geo3d.GeoPoint

      `latitude, longitude, magnitude`

    - ### Fields inherited from class org.apache.lucene.geo3d.Vector

      `MINIMUM_RESOLUTION, MINIMUM_RESOLUTION_CUBED, MINIMUM_RESOLUTION_SQUARED, x, y, z`

    - ### Fields inherited from interface org.apache.lucene.geo3d.GeoArea

      `CONTAINS, DISJOINT, OVERLAPS, WITHIN`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GeoDegeneratePoint(PlanetModel planetModel, double lat, double lon)` Constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `computeDistance(DistanceStyle distanceStyle, double x, double y, double z)` Compute this shape's internal "distance" to the GeoPoint.
    `double` | `computeDistance(DistanceStyle distanceStyle, GeoPoint point)` Compute this shape's internal "distance" to the GeoPoint.
    `double` | `computeOutsideDistance(DistanceStyle distanceStyle, double x, double y, double z)` Compute this shape's distance to the GeoPoint.
    `double` | `computeOutsideDistance(DistanceStyle distanceStyle, GeoPoint point)` Compute this shape's distance to the GeoPoint.
    `boolean` | `equals(Object o)`
    `GeoBBox` | `expand(double angle)` Expand box by specified angle.
    `void` | `getBounds(Bounds bounds)` Compute bounds for the shape.
    `GeoPoint` | `getCenter()` Returns the center of a circle into which the area will be inscribed.
    `GeoPoint[]` | `getEdgePoints()` Return a sample point that is on the outside edge/boundary of the shape.
    `double` | `getRadius()` Returns the radius of a circle into which the GeoSizeable area can be inscribed.
    `int` | `getRelationship(GeoShape shape)` Find the spatial relationship between a shape and the current geo area.
    `boolean` | `intersects(Plane plane, GeoPoint[] notablePoints, Membership... bounds)` Assess whether a plane, within the provided bounds, intersects with the shape.
    `boolean` | `isWithin(double x, double y, double z)` Check if a point is within this shape.
    `boolean` | `isWithin(Vector point)` Check if a point is within this shape.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.lucene.geo3d.GeoPoint

      `arcDistance, arcDistance, getLatitude, getLongitude, isIdentical, magnitude`

    - ### Methods inherited from class org.apache.lucene.geo3d.Vector

      `computeDesiredEllipsoidMagnitude, computeDesiredEllipsoidMagnitude, dotProduct, dotProduct, hashCode, isWithin, linearDistance, linearDistance, linearDistanceSquared, linearDistanceSquared, magnitude, normalDistance, normalDistance, normalDistanceSquared, normalDistanceSquared, normalize, rotateXY, rotateXY, rotateXZ, rotateXZ, rotateZY, rotateZY, translate`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### planetModel

          protected final PlanetModel planetModel

      Current planet model, since we don't extend BasePlanetObject

    - #### edgePoints

          protected final GeoPoint[] edgePoints

      Edge point is an area containing just this

  - ### Constructor Detail

    - #### GeoDegeneratePoint

          public GeoDegeneratePoint(PlanetModel planetModel,
                            double lat,
                            double lon)

      Constructor.
      Parameters:
        `planetModel` - is the planet model to use.
        `lat` - is the latitude.
        `lon` - is the longitude.

  - ### Method Detail

    - #### expand

          public GeoBBox expand(double angle)

      Description copied from interface: `GeoBBox`
      Expand box by specified angle.
      Specified by:
        `expand` in interface `GeoBBox`
      Parameters:
        `angle` - is the angle amount to expand the GeoBBox by.
      Returns:
        a new GeoBBox.

    - #### getEdgePoints

          public GeoPoint[] getEdgePoints()

      Description copied from interface: `GeoShape`
      Return a sample point that is on the outside edge/boundary of the shape.
      Specified by:
        `getEdgePoints` in interface `GeoShape`
      Returns:
        samples of all edge points from distinct edge sections. Typically one point is returned, but zero or two are also possible.

    - #### intersects

          public boolean intersects(Plane plane,
                           GeoPoint[] notablePoints,
                           Membership... bounds)

      Description copied from interface: `GeoShape`
      Assess whether a plane, within the provided bounds, intersects with the shape. Note well that this method is allowed to return "true" if there are internal edges of a composite shape which intersect the plane. Doing this can cause getRelationship() for most GeoBBox shapes to return OVERLAPS rather than the more correct CONTAINS, but that cannot be helped for some complex shapes that are built out of overlapping parts.
      Specified by:
        `intersects` in interface `GeoShape`
      Parameters:
        `plane` - is the plane to assess for intersection with the shape's edges or bounding curves.
        `notablePoints` - represents the intersections of the plane with the supplied bounds. These are used to disambiguate when two planes are identical and it needs to be determined whether any points exist that fulfill all the bounds.
        `bounds` - are a set of bounds that define an area that an intersection must be within in order to qualify (provided by a GeoArea).
      Returns:
        true if there's such an intersection, false if not.

    - #### getBounds

          public void getBounds(Bounds bounds)

      Description copied from interface: `GeoShape`
      Compute bounds for the shape.
      Specified by:
        `getBounds` in interface `GeoShape`
      Parameters:
        `bounds` - is the input bounds object. The input object will be modified.

    - #### computeOutsideDistance

          public double computeOutsideDistance(DistanceStyle distanceStyle,
                                      GeoPoint point)

      Description copied from interface: `GeoOutsideDistance`
      Compute this shape's distance to the GeoPoint. A return value of 0.0 should be returned for points inside of the shape.
      Specified by:
        `computeOutsideDistance` in interface `GeoOutsideDistance`
      Parameters:
        `distanceStyle` - is the distance style.
        `point` - is the point to compute the distance to.
      Returns:
        the distance.

    - #### computeOutsideDistance

          public double computeOutsideDistance(DistanceStyle distanceStyle,
                                      double x,
                                      double y,
                                      double z)

      Description copied from interface: `GeoOutsideDistance`
      Compute this shape's distance to the GeoPoint. A return value of 0.0 should be returned for points inside of the shape.
      Specified by:
        `computeOutsideDistance` in interface `GeoOutsideDistance`
      Parameters:
        `distanceStyle` - is the distance style.
        `x` - is the point's unit x coordinate (using U.S. convention).
        `y` - is the point's unit y coordinate (using U.S. convention).
        `z` - is the point's unit z coordinate (using U.S. convention).
      Returns:
        the distance.

    - #### computeDistance

          public double computeDistance(DistanceStyle distanceStyle,
                               GeoPoint point)

      Description copied from interface: `GeoDistance`
      Compute this shape's internal "distance" to the GeoPoint. Implementations should clarify how this is computed when it's non-obvious. A return value of Double.MAX_VALUE should be returned for points outside of the shape.
      Specified by:
        `computeDistance` in interface `GeoDistance`
      Parameters:
        `distanceStyle` - is the distance style.
        `point` - is the point to compute the distance to.
      Returns:
        the distance.

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Vector`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `GeoPoint`

    - #### isWithin

          public boolean isWithin(Vector point)

      Description copied from interface: `Membership`
      Check if a point is within this shape.
      Specified by:
        `isWithin` in interface `Membership`
      Parameters:
        `point` - is the point to check.
      Returns:
        true if the point is within this shape

    - #### isWithin

          public boolean isWithin(double x,
                         double y,
                         double z)

      Description copied from interface: `Membership`
      Check if a point is within this shape.
      Specified by:
        `isWithin` in interface `Membership`
      Parameters:
        `x` - is x coordinate of point to check.
        `y` - is y coordinate of point to check.
        `z` - is z coordinate of point to check.
      Returns:
        true if the point is within this shape

    - #### getRadius

          public double getRadius()

      Description copied from interface: `GeoSizeable`
      Returns the radius of a circle into which the GeoSizeable area can be inscribed.
      Specified by:
        `getRadius` in interface `GeoSizeable`
      Returns:
        the radius.

    - #### getCenter

          public GeoPoint getCenter()

      Description copied from interface: `GeoSizeable`
      Returns the center of a circle into which the area will be inscribed.
      Specified by:
        `getCenter` in interface `GeoSizeable`
      Returns:
        the center.

    - #### getRelationship

          public int getRelationship(GeoShape shape)

      Description copied from interface: `GeoArea`
      Find the spatial relationship between a shape and the current geo area. Note: return value is how the GeoShape relates to the GeoArea, not the other way around. For example, if this GeoArea is entirely within the shape, then CONTAINS should be returned. If the shape is entirely enclosed by this GeoArea, then WITHIN should be returned. It is permissible to return OVERLAPS instead of WITHIN if the shape intersects with the area at even a single point. So, a circle inscribed in a rectangle could return either OVERLAPS or WITHIN, depending on implementation. It is not permissible to return CONTAINS or DISJOINT in this circumstance, however. Similarly, it is permissible to return OVERLAPS instead of CONTAINS under conditions where the shape consists of multiple independent overlapping subshapes, and the area overlaps one of the subshapes. It is not permissible to return WITHIN or DISJOINT in this circumstance, however.
      Specified by:
        `getRelationship` in interface `GeoArea`
      Parameters:
        `shape` - is the shape to consider.
      Returns:
        the relationship, from the perspective of the shape.

    - #### computeDistance

          public double computeDistance(DistanceStyle distanceStyle,
                               double x,
                               double y,
                               double z)

      Description copied from interface: `GeoDistance`
      Compute this shape's internal "distance" to the GeoPoint. Implementations should clarify how this is computed when it's non-obvious. A return value of Double.MAX_VALUE should be returned for points outside of the shape.
      Specified by:
        `computeDistance` in interface `GeoDistance`
        `x` - is the point's unit x coordinate (using U.S. convention).
        `y` - is the point's unit y coordinate (using U.S. convention).
        `z` - is the point's unit z coordinate (using U.S. convention).
      Returns:
        the distance.

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.